# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class GenCustomerFragment(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'description': 'str',
        'hsm_key_label': 'str',
        'json': 'bool',
        'metadata': 'str',
        'name': 'str',
        'type': 'str'
    }

    attribute_map = {
        'description': 'description',
        'hsm_key_label': 'hsm-key-label',
        'json': 'json',
        'metadata': 'metadata',
        'name': 'name',
        'type': 'type'
    }

    def __init__(self, description=None, hsm_key_label=None, json=False, metadata=None, name=None, type='standard', local_vars_configuration=None):  # noqa: E501
        """GenCustomerFragment - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._description = None
        self._hsm_key_label = None
        self._json = None
        self._metadata = None
        self._name = None
        self._type = None
        self.discriminator = None

        if description is not None:
            self.description = description
        if hsm_key_label is not None:
            self.hsm_key_label = hsm_key_label
        if json is not None:
            self.json = json
        if metadata is not None:
            self.metadata = metadata
        if name is not None:
            self.name = name
        if type is not None:
            self.type = type

    @property
    def description(self):
        """Gets the description of this GenCustomerFragment.  # noqa: E501

        Description of the object  # noqa: E501

        :return: The description of this GenCustomerFragment.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this GenCustomerFragment.

        Description of the object  # noqa: E501

        :param description: The description of this GenCustomerFragment.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def hsm_key_label(self):
        """Gets the hsm_key_label of this GenCustomerFragment.  # noqa: E501

        The label of the hsm key to use for customer fragment operations (relevant for hsm_wrapped/hsm_protected customer fragments)  # noqa: E501

        :return: The hsm_key_label of this GenCustomerFragment.  # noqa: E501
        :rtype: str
        """
        return self._hsm_key_label

    @hsm_key_label.setter
    def hsm_key_label(self, hsm_key_label):
        """Sets the hsm_key_label of this GenCustomerFragment.

        The label of the hsm key to use for customer fragment operations (relevant for hsm_wrapped/hsm_protected customer fragments)  # noqa: E501

        :param hsm_key_label: The hsm_key_label of this GenCustomerFragment.  # noqa: E501
        :type: str
        """

        self._hsm_key_label = hsm_key_label

    @property
    def json(self):
        """Gets the json of this GenCustomerFragment.  # noqa: E501

        Set output format to JSON  # noqa: E501

        :return: The json of this GenCustomerFragment.  # noqa: E501
        :rtype: bool
        """
        return self._json

    @json.setter
    def json(self, json):
        """Sets the json of this GenCustomerFragment.

        Set output format to JSON  # noqa: E501

        :param json: The json of this GenCustomerFragment.  # noqa: E501
        :type: bool
        """

        self._json = json

    @property
    def metadata(self):
        """Gets the metadata of this GenCustomerFragment.  # noqa: E501

        Deprecated - use description  # noqa: E501

        :return: The metadata of this GenCustomerFragment.  # noqa: E501
        :rtype: str
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this GenCustomerFragment.

        Deprecated - use description  # noqa: E501

        :param metadata: The metadata of this GenCustomerFragment.  # noqa: E501
        :type: str
        """

        self._metadata = metadata

    @property
    def name(self):
        """Gets the name of this GenCustomerFragment.  # noqa: E501

        Customer fragment name  # noqa: E501

        :return: The name of this GenCustomerFragment.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GenCustomerFragment.

        Customer fragment name  # noqa: E501

        :param name: The name of this GenCustomerFragment.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """Gets the type of this GenCustomerFragment.  # noqa: E501

        Customer fragment type [standard/hsm_wrapped/hsm_secured]  # noqa: E501

        :return: The type of this GenCustomerFragment.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this GenCustomerFragment.

        Customer fragment type [standard/hsm_wrapped/hsm_secured]  # noqa: E501

        :param type: The type of this GenCustomerFragment.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenCustomerFragment):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GenCustomerFragment):
            return True

        return self.to_dict() != other.to_dict()
