# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class GetRotatedSecretValue(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'host': 'str',
        'ignore_cache': 'str',
        'json': 'bool',
        'names': 'str',
        'token': 'str',
        'uid_token': 'str',
        'version': 'int'
    }

    attribute_map = {
        'host': 'host',
        'ignore_cache': 'ignore-cache',
        'json': 'json',
        'names': 'names',
        'token': 'token',
        'uid_token': 'uid-token',
        'version': 'version'
    }

    def __init__(self, host=None, ignore_cache='false', json=False, names=None, token=None, uid_token=None, version=None, local_vars_configuration=None):  # noqa: E501
        """GetRotatedSecretValue - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._host = None
        self._ignore_cache = None
        self._json = None
        self._names = None
        self._token = None
        self._uid_token = None
        self._version = None
        self.discriminator = None

        if host is not None:
            self.host = host
        if ignore_cache is not None:
            self.ignore_cache = ignore_cache
        if json is not None:
            self.json = json
        self.names = names
        if token is not None:
            self.token = token
        if uid_token is not None:
            self.uid_token = uid_token
        if version is not None:
            self.version = version

    @property
    def host(self):
        """Gets the host of this GetRotatedSecretValue.  # noqa: E501

        Get rotated secret value of specific Host (relevant only for Linked Target)  # noqa: E501

        :return: The host of this GetRotatedSecretValue.  # noqa: E501
        :rtype: str
        """
        return self._host

    @host.setter
    def host(self, host):
        """Sets the host of this GetRotatedSecretValue.

        Get rotated secret value of specific Host (relevant only for Linked Target)  # noqa: E501

        :param host: The host of this GetRotatedSecretValue.  # noqa: E501
        :type: str
        """

        self._host = host

    @property
    def ignore_cache(self):
        """Gets the ignore_cache of this GetRotatedSecretValue.  # noqa: E501

        Retrieve the Secret value without checking the Gateway's cache [true/false]. This flag is only relevant when using the RestAPI  # noqa: E501

        :return: The ignore_cache of this GetRotatedSecretValue.  # noqa: E501
        :rtype: str
        """
        return self._ignore_cache

    @ignore_cache.setter
    def ignore_cache(self, ignore_cache):
        """Sets the ignore_cache of this GetRotatedSecretValue.

        Retrieve the Secret value without checking the Gateway's cache [true/false]. This flag is only relevant when using the RestAPI  # noqa: E501

        :param ignore_cache: The ignore_cache of this GetRotatedSecretValue.  # noqa: E501
        :type: str
        """

        self._ignore_cache = ignore_cache

    @property
    def json(self):
        """Gets the json of this GetRotatedSecretValue.  # noqa: E501

        Set output format to JSON  # noqa: E501

        :return: The json of this GetRotatedSecretValue.  # noqa: E501
        :rtype: bool
        """
        return self._json

    @json.setter
    def json(self, json):
        """Sets the json of this GetRotatedSecretValue.

        Set output format to JSON  # noqa: E501

        :param json: The json of this GetRotatedSecretValue.  # noqa: E501
        :type: bool
        """

        self._json = json

    @property
    def names(self):
        """Gets the names of this GetRotatedSecretValue.  # noqa: E501

        Secret name  # noqa: E501

        :return: The names of this GetRotatedSecretValue.  # noqa: E501
        :rtype: str
        """
        return self._names

    @names.setter
    def names(self, names):
        """Sets the names of this GetRotatedSecretValue.

        Secret name  # noqa: E501

        :param names: The names of this GetRotatedSecretValue.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and names is None:  # noqa: E501
            raise ValueError("Invalid value for `names`, must not be `None`")  # noqa: E501

        self._names = names

    @property
    def token(self):
        """Gets the token of this GetRotatedSecretValue.  # noqa: E501

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :return: The token of this GetRotatedSecretValue.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this GetRotatedSecretValue.

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :param token: The token of this GetRotatedSecretValue.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def uid_token(self):
        """Gets the uid_token of this GetRotatedSecretValue.  # noqa: E501

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :return: The uid_token of this GetRotatedSecretValue.  # noqa: E501
        :rtype: str
        """
        return self._uid_token

    @uid_token.setter
    def uid_token(self, uid_token):
        """Sets the uid_token of this GetRotatedSecretValue.

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :param uid_token: The uid_token of this GetRotatedSecretValue.  # noqa: E501
        :type: str
        """

        self._uid_token = uid_token

    @property
    def version(self):
        """Gets the version of this GetRotatedSecretValue.  # noqa: E501

        Secret version  # noqa: E501

        :return: The version of this GetRotatedSecretValue.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this GetRotatedSecretValue.

        Secret version  # noqa: E501

        :param version: The version of this GetRotatedSecretValue.  # noqa: E501
        :type: int
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetRotatedSecretValue):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetRotatedSecretValue):
            return True

        return self.to_dict() != other.to_dict()
