# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class SignDataWithClassicKey(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'data': 'str',
        'display_id': 'str',
        'hashed': 'bool',
        'hashing_method': 'str',
        'ignore_cache': 'str',
        'json': 'bool',
        'name': 'str',
        'token': 'str',
        'uid_token': 'str',
        'version': 'int'
    }

    attribute_map = {
        'data': 'data',
        'display_id': 'display-id',
        'hashed': 'hashed',
        'hashing_method': 'hashing-method',
        'ignore_cache': 'ignore-cache',
        'json': 'json',
        'name': 'name',
        'token': 'token',
        'uid_token': 'uid-token',
        'version': 'version'
    }

    def __init__(self, data=None, display_id=None, hashed=False, hashing_method='SHA256', ignore_cache='false', json=False, name=None, token=None, uid_token=None, version=None, local_vars_configuration=None):  # noqa: E501
        """SignDataWithClassicKey - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._data = None
        self._display_id = None
        self._hashed = None
        self._hashing_method = None
        self._ignore_cache = None
        self._json = None
        self._name = None
        self._token = None
        self._uid_token = None
        self._version = None
        self.discriminator = None

        self.data = data
        self.display_id = display_id
        if hashed is not None:
            self.hashed = hashed
        if hashing_method is not None:
            self.hashing_method = hashing_method
        if ignore_cache is not None:
            self.ignore_cache = ignore_cache
        if json is not None:
            self.json = json
        self.name = name
        if token is not None:
            self.token = token
        if uid_token is not None:
            self.uid_token = uid_token
        self.version = version

    @property
    def data(self):
        """Gets the data of this SignDataWithClassicKey.  # noqa: E501

        Data  # noqa: E501

        :return: The data of this SignDataWithClassicKey.  # noqa: E501
        :rtype: str
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this SignDataWithClassicKey.

        Data  # noqa: E501

        :param data: The data of this SignDataWithClassicKey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and data is None:  # noqa: E501
            raise ValueError("Invalid value for `data`, must not be `None`")  # noqa: E501

        self._data = data

    @property
    def display_id(self):
        """Gets the display_id of this SignDataWithClassicKey.  # noqa: E501

        The name of the key to use in the sign data process  # noqa: E501

        :return: The display_id of this SignDataWithClassicKey.  # noqa: E501
        :rtype: str
        """
        return self._display_id

    @display_id.setter
    def display_id(self, display_id):
        """Sets the display_id of this SignDataWithClassicKey.

        The name of the key to use in the sign data process  # noqa: E501

        :param display_id: The display_id of this SignDataWithClassicKey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and display_id is None:  # noqa: E501
            raise ValueError("Invalid value for `display_id`, must not be `None`")  # noqa: E501

        self._display_id = display_id

    @property
    def hashed(self):
        """Gets the hashed of this SignDataWithClassicKey.  # noqa: E501

        Defines whether the data should be hashed as part of the signing. If true, the data will not be hashed  # noqa: E501

        :return: The hashed of this SignDataWithClassicKey.  # noqa: E501
        :rtype: bool
        """
        return self._hashed

    @hashed.setter
    def hashed(self, hashed):
        """Sets the hashed of this SignDataWithClassicKey.

        Defines whether the data should be hashed as part of the signing. If true, the data will not be hashed  # noqa: E501

        :param hashed: The hashed of this SignDataWithClassicKey.  # noqa: E501
        :type: bool
        """

        self._hashed = hashed

    @property
    def hashing_method(self):
        """Gets the hashing_method of this SignDataWithClassicKey.  # noqa: E501

        HashingMethod  # noqa: E501

        :return: The hashing_method of this SignDataWithClassicKey.  # noqa: E501
        :rtype: str
        """
        return self._hashing_method

    @hashing_method.setter
    def hashing_method(self, hashing_method):
        """Sets the hashing_method of this SignDataWithClassicKey.

        HashingMethod  # noqa: E501

        :param hashing_method: The hashing_method of this SignDataWithClassicKey.  # noqa: E501
        :type: str
        """

        self._hashing_method = hashing_method

    @property
    def ignore_cache(self):
        """Gets the ignore_cache of this SignDataWithClassicKey.  # noqa: E501

        Retrieve the Secret value without checking the Gateway's cache [true/false]. This flag is only relevant when using the RestAPI  # noqa: E501

        :return: The ignore_cache of this SignDataWithClassicKey.  # noqa: E501
        :rtype: str
        """
        return self._ignore_cache

    @ignore_cache.setter
    def ignore_cache(self, ignore_cache):
        """Sets the ignore_cache of this SignDataWithClassicKey.

        Retrieve the Secret value without checking the Gateway's cache [true/false]. This flag is only relevant when using the RestAPI  # noqa: E501

        :param ignore_cache: The ignore_cache of this SignDataWithClassicKey.  # noqa: E501
        :type: str
        """

        self._ignore_cache = ignore_cache

    @property
    def json(self):
        """Gets the json of this SignDataWithClassicKey.  # noqa: E501

        Set output format to JSON  # noqa: E501

        :return: The json of this SignDataWithClassicKey.  # noqa: E501
        :rtype: bool
        """
        return self._json

    @json.setter
    def json(self, json):
        """Sets the json of this SignDataWithClassicKey.

        Set output format to JSON  # noqa: E501

        :param json: The json of this SignDataWithClassicKey.  # noqa: E501
        :type: bool
        """

        self._json = json

    @property
    def name(self):
        """Gets the name of this SignDataWithClassicKey.  # noqa: E501

        ClassicKey name  # noqa: E501

        :return: The name of this SignDataWithClassicKey.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SignDataWithClassicKey.

        ClassicKey name  # noqa: E501

        :param name: The name of this SignDataWithClassicKey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def token(self):
        """Gets the token of this SignDataWithClassicKey.  # noqa: E501

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :return: The token of this SignDataWithClassicKey.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this SignDataWithClassicKey.

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :param token: The token of this SignDataWithClassicKey.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def uid_token(self):
        """Gets the uid_token of this SignDataWithClassicKey.  # noqa: E501

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :return: The uid_token of this SignDataWithClassicKey.  # noqa: E501
        :rtype: str
        """
        return self._uid_token

    @uid_token.setter
    def uid_token(self, uid_token):
        """Sets the uid_token of this SignDataWithClassicKey.

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :param uid_token: The uid_token of this SignDataWithClassicKey.  # noqa: E501
        :type: str
        """

        self._uid_token = uid_token

    @property
    def version(self):
        """Gets the version of this SignDataWithClassicKey.  # noqa: E501

        classic key version  # noqa: E501

        :return: The version of this SignDataWithClassicKey.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this SignDataWithClassicKey.

        classic key version  # noqa: E501

        :param version: The version of this SignDataWithClassicKey.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and version is None:  # noqa: E501
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SignDataWithClassicKey):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SignDataWithClassicKey):
            return True

        return self.to_dict() != other.to_dict()
